﻿
using System;
using System.ComponentModel.DataAnnotations;
using Kreta.BusinessLogic.HelperClasses;
using Kreta.BusinessLogic.Interfaces;
using Kreta.Core.CustomAttributes;
using Kreta.Resources;
using Kreta.Web.Attributes;

namespace Kreta.Web.Areas.Intezmeny.Models
{
    public class CsengetesiRendGridModel : IKretaIdentity
    {

        public const string CsengetesiRendExportAttributeId = nameof(CsengetesiRendExportAttributeId);

        public CsengetesiRendGridModel()
        {

        }

        public CsengetesiRendGridModel(CsengetesiRendItemCo itemCo)
        {
            ID = itemCo.Id.ToString();
            Nev = itemCo.CsengetesiRendNev;
            IsAktivText = itemCo.IsAktivText;
        }

        public string ID { get; set; }

        [SimpleExportColumn(CsengetesiRendExportAttributeId, 00, nameof(CsengetesiRendResource.CsengetesiRendNeve), typeof(CsengetesiRendResource))]
        [Display(Name = nameof(CsengetesiRendResource.CsengetesiRendNeve), ResourceType = typeof(CsengetesiRendResource))]
        public string Nev { get; set; }

        [SimpleExportColumn(CsengetesiRendExportAttributeId, 01, nameof(CsengetesiRendResource.Aktiv), typeof(CsengetesiRendResource))]
        [Display(Name = nameof(CsengetesiRendResource.Aktiv), ResourceType = typeof(CsengetesiRendResource))]
        public string IsAktivText { get; set; }
    }

    public class CsengetesiRendOraGridModel : IKretaIdentity
    {
        public string ID { get; set; }

        [KretaDisplayName(667)] //Kezdete
        public string Kezdete { get; set; }

        [KretaDisplayName(129)] //Aktív
        public bool IsReal_BOOL { get; set; }

        [KretaDisplayName(668)] //Vége
        public string Vege { get; set; }

        [KretaDisplayName(274)] //Óraszám
        public int Oraszam { get; set; }

        public bool IsHaveReferences { get; set; }
    }

    public class CsengetesiRendTanevrendGridModel : IKretaIdentity
    {
        public string ID { get; set; }

        [KretaDisplayName(273)] //Dátum
        public DateTime Datum { get; set; }

        [KretaDisplayName(108)] //Név
        public string Nev { get; set; }

        [KretaDisplayName(671)] //Naptípus
        public string Tipus { get; set; }

        [KretaDisplayName(671)] //Naptípus
        public string Tipus_DNAME { get; set; }
    }
}
