﻿using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Web.Mvc;
using Kreta.BusinessLogic.Classes;
using Kreta.Resources;
using Kreta.Web.Attributes;
using Kreta.Web.Helpers.TabStrip;

namespace Kreta.Web.Areas.Intezmeny.Models
{
    public class CsengetesiRendModel
    {
        public CsengetesiRendModel()
        {
            TabList = new List<TabStripItemModel>();
            MukodesiHelyList = new List<SelectListItem>();
        }

        public int? ID { get; set; }
        public bool Aktiv { get; set; }
        public bool BeszurasEle { get; set; }

        [KretaDisplayName(1688)] /*Csengetési rend neve*/
        [KretaRequired(StringResourcesId = 2331)] /*Név megadása kötelező*/
        [StringLength(maximumLength: 50, ErrorMessageResourceName = nameof(ErrorResource.CsengRendNevMax50Karakter), ErrorMessageResourceType = typeof(ErrorResource))]
        public string Nev { get; set; }

        [Display(Name = nameof(CsengetesiRendResource.VisszamenolegesModositas), ResourceType = typeof(CsengetesiRendResource))]
        public bool IsVisszamenoleges { get; set; }

        public List<TabStripItemModel> TabList { get; set; }
        public List<SelectListItem> MukodesiHelyList { get; set; }
    }

    public class SaveCsengetesiRendModel
    {
        public SaveCsengetesiRendModel()
        {
            Orak = new List<CsengetesiRendOraModel>();
        }

        public int CsengRendID { get; set; }
        public string CsengRendNev { get; set; }
        public bool CsengRendAktiv { get; set; }
        public bool IsVisszamenoleges { get; set; }
        public List<CsengetesiRendOraModel> Orak { get; set; }
    }

    public class CsengetesiRendOraModel
    {
        public int? ID { get; set; }
        public int Oraszam { get; set; }
        public string Kezd { get; set; }
        public string Veg { get; set; }
        public bool Aktiv { get; set; }
    }

    public class CsengetesiRendTorlesModel
    {
        public int? ID { get; set; }
        public int? CsengetesiRendID { get; set; }
    }
}
