﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Web.Mvc;
using Kreta.BusinessLogic.Classes;
using Kreta.Resources;

namespace Kreta.Web.Areas.Intezmeny.Models
{
    public class EszkozCsopModModel
    {
        public int? EszkozId { get; set; }

        [Display(Name = nameof(EszkozResource.EszkozNeve), ResourceType = typeof(EszkozResource))]
        public string EszkozNev { get; set; }

        public string EszkozIdArray { get; set; }

        [Display(Name = nameof(EszkozResource.KivalasztottEszkozok), ResourceType = typeof(EszkozResource))]
        public string EszkozNevArray { get; set; }

        [Display(Name = nameof(EszkozResource.FellelhetosegiHely), ResourceType = typeof(EszkozResource))]
        public int? TeremID { get; set; }

        [Display(Name = nameof(EszkozResource.EszkozTipusa), ResourceType = typeof(EszkozResource))]
        public int? Tipus { get; set; }

        [Display(Name = nameof(EszkozResource.Kategoria), ResourceType = typeof(EszkozResource))]
        public int? Kategoria { get; set; }

        [Display(Name = nameof(EszkozResource.BeszerzesDatuma), ResourceType = typeof(EszkozResource))]
        public DateTime? BeszerzesDatum { get; set; }

        [Display(Name = nameof(EszkozResource.Mennyiseg), ResourceType = typeof(EszkozResource))]
        [KretaParameterizedRange(0, 99999, ErrorMessageResourceName = nameof(ErrorResource.EszkozAMennyisegCsakEgyParameterekKozottiEgeszSzamLehet), ErrorMessageResourceType = typeof(ErrorResource))]
        public int? Darabszam { get; set; }

        [Display(Name = nameof(EszkozResource.FelelosSzemely), ResourceType = typeof(EszkozResource))]
        public int? SzemelyiFelelos { get; set; }

        [Display(Name = nameof(EszkozResource.GyartasiEv), ResourceType = typeof(EszkozResource))]
        [KretaRegularExpression(Core.Constants.RegularExpressions.GyartasiEv, ErrorMessageResourceName = nameof(ErrorResource.GyartasiEvFormatumaNemMegfelelo), ErrorMessageResourceType = typeof(ErrorResource))]
        public int? GyartasiEv { get; set; }

        [Display(Name = nameof(EszkozResource.Multimedias), ResourceType = typeof(EszkozResource))]
        public int? Multimedias { get; set; }

        [Display(Name = nameof(EszkozResource.HalotatiKapcsolat), ResourceType = typeof(EszkozResource))]
        public int? HalozatiKapcsolat { get; set; }

        [Display(Name = nameof(EszkozResource.Internetkapcsolat), ResourceType = typeof(EszkozResource))]
        public int? InternetKapcsolat { get; set; }

        [Display(Name = nameof(EszkozResource.Hordozhato), ResourceType = typeof(EszkozResource))]
        public int? Hordozhato { get; set; }

        [Display(Name = nameof(EszkozResource.Tartozek), ResourceType = typeof(EszkozResource))]
        public bool Tartozek { get; set; }

        [Display(Name = nameof(EszkozResource.TartozekHivatkozas), ResourceType = typeof(EszkozResource))]
        public string TartozekHivatkozas { get; set; }

        [Display(Name = nameof(EszkozResource.Megjegyzes), ResourceType = typeof(EszkozResource))]
        [StringLength(255, ErrorMessageResourceName = nameof(ErrorResource.AMegjegyzesMax255KarakterLehet), ErrorMessageResourceType = typeof(ErrorResource))]
        public string Megjegyzes { get; set; }

        [Display(Name = nameof(EszkozResource.EszkozFelhasznalas), ResourceType = typeof(EszkozResource))]
        public int? Celja { get; set; }

        [Display(Name = nameof(EszkozResource.Berelt), ResourceType = typeof(EszkozResource))]
        public int? Berelt { get; set; }

        [Display(Name = nameof(EszkozResource.TanuloHozzaferhet), ResourceType = typeof(EszkozResource))]
        public int? TanuloHozzaferhet { get; set; }

        [Display(Name = nameof(EszkozResource.PedagogusHozzaferhet), ResourceType = typeof(EszkozResource))]
        public int? PedagogusHozzaferhet { get; set; }

        public EszkozCsopModModel()
        {
            IgenNemList = GetIgenNemList();
        }

        private List<SelectListItem> GetIgenNemList()
        {
            List<SelectListItem> list = new List<SelectListItem>();

            list.Add(new SelectListItem() { Text = CommonResource.Igen, Value = ((int)Enums.ManualEnums.IgenNemEnum.Igen).ToString() });
            list.Add(new SelectListItem() { Text = CommonResource.Nem, Value = ((int)Enums.ManualEnums.IgenNemEnum.Nem).ToString() });

            return list;
        }

        public List<SelectListItem> IgenNemList { get; set; }

        [Display(Name = nameof(EszkozResource.HibasEszkoz), ResourceType = typeof(EszkozResource))]
        public int? NemMukodik { get; set; }
    }
}
