﻿using System.ComponentModel.DataAnnotations;
using Kreta.BusinessLogic.Classes;
using Kreta.BusinessLogic.HelperClasses;
using Kreta.Resources;

namespace Kreta.Web.Areas.Intezmeny.Models
{
    public class EszkozSearchModel
    {
        [Display(Name = nameof(EszkozResource.EszkozMegnevezese), ResourceType = typeof(EszkozResource))]
        public string SearchNev { get; set; }

        [Display(Name = nameof(EszkozResource.StatisztikaiKategoria), ResourceType = typeof(EszkozResource))]
        public int? SearchKategoria { get; set; }

        [Display(Name = nameof(EszkozResource.MennyisegtolIg), ResourceType = typeof(EszkozResource))]
        [KretaParameterizedRange(0, 99999, ErrorMessageResourceName = nameof(ErrorResource.EszkozAMennyisegCsakEgyParameterekKozottiEgeszSzamLehet), ErrorMessageResourceType = typeof(ErrorResource))]  //A darabszám csak egy 1 és 99999 közötti egész szám lehet
        public int? SearchMinDarabszam { get; set; }

        [Display(Name = nameof(EszkozResource.MennyisegtolIg), ResourceType = typeof(EszkozResource))]
        [KretaParameterizedRange(0, 99999, ErrorMessageResourceName = nameof(ErrorResource.EszkozAMennyisegCsakEgyParameterekKozottiEgeszSzamLehet), ErrorMessageResourceType = typeof(ErrorResource))]  //A darabszám csak egy 1 és 99999 közötti egész szám lehet
        public int? SearchMaxDarabszam { get; set; }

        [Display(Name = nameof(EszkozResource.Helyiseg), ResourceType = typeof(EszkozResource))]
        public int? SearchTeremID { get; set; }

        [Display(Name = nameof(EszkozResource.FelelosSzemely), ResourceType = typeof(EszkozResource))]
        public int? SearchFelelosID { get; set; }

        public bool IsEszkozKezelesEnabled { get; set; }

        public EszkozokSearchCo ConvertToCo(int tanevId)
        {
            return new EszkozokSearchCo
            {
                TanevId = tanevId,
                TeremId = this.SearchTeremID,
                FelelosId = this.SearchFelelosID,
                KategoriaId = this.SearchKategoria,
                MinDarabszam = this.SearchMinDarabszam,
                MaxDarabszam = this.SearchMaxDarabszam,
                Nev = this.SearchNev
            };
        }
    }
}
