﻿using System;
using System.Collections.Generic;
using System.Globalization;
using Kreta.Core;

namespace Kreta.Web.Areas.Intezmeny.Models
{
    public class FaliujsagElem
    {
        public string Nev { get; set; }

        public string Munkakor { get; set; }

        public string KepEleresiUtja { get; set; }

        public DateTime Idopont { get; set; }

        public string EsemenyCime { get; set; }

        public string EsemenySzovege { get; set; }

        public string DatumNap { get { return Idopont.Day.ToString(); } }

        public string DatumHonap { get { return CultureInfo.CurrentCulture.DateTimeFormat.GetAbbreviatedMonthName(Idopont.Month); } }

        public string DatumEv { get { return Idopont.Year.ToString(); } }
    }

    public class FaliujsagModel
    {
        public FaliujsagModel()
        {
            FaliujsagElemek = new List<FaliujsagElem>();
        }

        public List<FaliujsagElem> FaliujsagElemek { get; set; }

        public int ItemCount { get; set; }

        public QuadrupleList<string, string, string, string> LegutobbiErtekelesek { get; set; }

        public QuintupleList<DateTime?, string, string, string, string> LegutobbiMulasztasok { get; set; }

        public QuadrupleList<string, string, string, string> LegutobbiFeljegyzesek { get; set; }

        public QuadrupleList<string, string, string, string> LegutobbiBejelentettSzamonkeresek { get; set; }
    }
}
