﻿using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Web.Mvc;
using Kreta.Resources;
using Kreta.Web.Controllers;
using Kreta.Web.Helpers.TabStrip;

namespace Kreta.Web.Areas.Intezmeny.Models
{
    public class FeladatellatasiHelyModel
    {
        public int? ID { get; set; }
        public int MukodesiHelyID { get; set; }

        [Display(Name = nameof(IntezmenyResource.MukodesiHely), ResourceType = typeof(IntezmenyResource))]
        public string MukodesiHelyNev { get; set; }

        [Display(Name = nameof(IntezmenyResource.EllatottKoznevelesiFeladat), ResourceType = typeof(IntezmenyResource))]
        [Required(ErrorMessageResourceName = nameof(IntezmenyResource.EllatottKoznevelesiFeladatKivalasztasaKotelezo), ErrorMessageResourceType = typeof(IntezmenyResource))]
        public int? FeladatTipus { get; set; }

        [Display(Name = nameof(IntezmenyResource.EllatottKoznevelesiFeladat), ResourceType = typeof(IntezmenyResource))]
        public string FeladatTipusNev { get; set; }

        [Display(Name = nameof(IntezmenyResource.KIRFeladatellatasiHelySorszama), ResourceType = typeof(IntezmenyResource))]
        public string KIRFeladatellatasiHelySorszama { get; set; }

        public List<SelectListItem> FeladatList { get; set; }

        public List<TabStripItemModel> TabList { get; set; }

        public bool IsAMIModuleActive { get; set; }
        public bool IsKollegiumModuleActive { get; set; }
        public bool IsEGYMIModuleActive { get; set; }

        public FeladatellatasiHelyModel()
        {
            FeladatList = new ComboBoxHelperApiController().GetOktatasiNevelesiFeladatList(true);
            TabList = new List<TabStripItemModel>();
        }
    }
}
