﻿using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using Kreta.BusinessLogic.Classes;
using Kreta.BusinessLogic.HelperClasses;
using Kreta.Resources;
using Kreta.Web.Helpers.TabStrip;

namespace Kreta.Web.Areas.Intezmeny.Models
{
    public class OktatottSzakmaInfoModel
    {
        public OktatottSzakmaInfoModel(UjSzktSzakmajegyzekOsszerendelesItemCo co)
        {
            var alapadatModel = new AlapadatModel
            {
                Id = co.Id.Value,
                SzakkepesitesMegnevezese = co.SzakkepesitesMegnevezese,
                OktatasiNevelesiFeladatNev = co.OktatasiNevelesiFeladatNev,
                AgazatiBesorolas = co.AgazatiBesorolas?.ToString("00"),
                SzakkepesitesAzonositoszam = co.SzakkepesitesAzonositoszam,
                JelenlegZajloKepzes = co.JelenlegZajloKepzes.GetDisplayName(),
                KepzesreFogadhatoTanulokSzama = co.KepzesreFogadhatoTanulokSzama.Value,
                JelenlegKepzettTanulokSzama = co.JelenlegKepzettTanulokSzama,
                IsNyilatkozott = co.IsNyilatkozott.GetDisplayName(),
                EszkozallomanyAvultsaga = co.EszkozallomanyAvultsaga,
                EszkozokDarabszama = co.EszkozokDarabszama,
                EgyebEszkozallomanyInformacio = co.EgyebEszkozallomanyInformacio,
                TanmuhelyekSzama = co.TanmuhelyekSzama,
            };

            TabList = new List<TabStripItemModel>
            {
                new TabStripItemModel
                {
                    ItemId = "1",
                    ItemName = UjSzktSzakmajegyzekOsszerendelesResource.Alapadatok,
                    Model = alapadatModel,
                    PartialViewName = "Info_Alapadatok_Tab",
                    IsActive = true
                },
                new TabStripItemModel
                {
                    ItemId = "2",
                    ItemName = UjSzktSzakmajegyzekOsszerendelesResource.SzakmatTanulokListaja,
                    Model = co.Id.Value,
                    PartialViewName = "Info_SzakmatTanulokListaja_Tab"
                }
            };
        }

        public List<TabStripItemModel> TabList { get; }

        public class AlapadatModel
        {
            public int Id { get; set; }

            [Display(Name = nameof(UjSzktSzakmajegyzekOsszerendelesResource.SzakkepesitesMegnevezese), ResourceType = typeof(UjSzktSzakmajegyzekOsszerendelesResource))]
            public string SzakkepesitesMegnevezese { get; set; }

            [Display(Name = nameof(UjSzktSzakmajegyzekOsszerendelesResource.OktatasiNevelesiFeladatNev), ResourceType = typeof(UjSzktSzakmajegyzekOsszerendelesResource))]
            public string OktatasiNevelesiFeladatNev { get; set; }

            [Display(Name = nameof(UjSzktSzakmajegyzekOsszerendelesResource.AgazatiBesorolas), ResourceType = typeof(UjSzktSzakmajegyzekOsszerendelesResource))]
            public string AgazatiBesorolas { get; set; }

            [Display(Name = nameof(UjSzktSzakmajegyzekOsszerendelesResource.SzakkepesitesAzonositoszam), ResourceType = typeof(UjSzktSzakmajegyzekOsszerendelesResource))]
            public string SzakkepesitesAzonositoszam { get; set; }

            [Display(Name = nameof(UjSzktSzakmajegyzekOsszerendelesResource.JelenlegZajloKepzes), ResourceType = typeof(UjSzktSzakmajegyzekOsszerendelesResource))]
            public string JelenlegZajloKepzes { get; set; }

            [Display(Name = nameof(UjSzktSzakmajegyzekOsszerendelesResource.KepzesreFogadhatoTanulokSzama), ResourceType = typeof(UjSzktSzakmajegyzekOsszerendelesResource))]
            public int KepzesreFogadhatoTanulokSzama { get; set; }

            [Display(Name = nameof(UjSzktSzakmajegyzekOsszerendelesResource.JelenlegKepzettTanulokSzama), ResourceType = typeof(UjSzktSzakmajegyzekOsszerendelesResource))]
            public int JelenlegKepzettTanulokSzama { get; set; }

            [Display(Name = nameof(UjSzktSzakmajegyzekOsszerendelesResource.Nyilatkozat), ResourceType = typeof(UjSzktSzakmajegyzekOsszerendelesResource))]
            public string IsNyilatkozott { get; set; }

            [Display(Name = nameof(UjSzktSzakmajegyzekOsszerendelesResource.EszkozallomanyAvultsaga), ResourceType = typeof(UjSzktSzakmajegyzekOsszerendelesResource))]
            public string EszkozallomanyAvultsaga { get; set; }

            [Display(Name = nameof(UjSzktSzakmajegyzekOsszerendelesResource.EszkozokDarabszama), ResourceType = typeof(UjSzktSzakmajegyzekOsszerendelesResource))]
            public string EszkozokDarabszama { get; set; }

            [Display(Name = nameof(UjSzktSzakmajegyzekOsszerendelesResource.EgyebEszkozallomanyInformacio), ResourceType = typeof(UjSzktSzakmajegyzekOsszerendelesResource))]
            public string EgyebEszkozallomanyInformacio { get; set; }

            [Display(Name = nameof(UjSzktSzakmajegyzekOsszerendelesResource.TanmuhelyekSzama), ResourceType = typeof(UjSzktSzakmajegyzekOsszerendelesResource))]
            public string TanmuhelyekSzama { get; set; }
        }
    }
}
