﻿using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using Kreta.BusinessLogic.HelperClasses;
using Kreta.Resources;

namespace Kreta.Web.Areas.Intezmeny.Models
{
    public class OktatottSzakmaMultipleModifyModel
    {
        public OktatottSzakmaMultipleModifyModel() { }

        public OktatottSzakmaMultipleModifyModel(List<UjSzktSzakmajegyzekOsszerendelesItemCo> coList)
        {
            IdsString = string.Join(",", coList.Select(x => x.Id).ToList());
            SzakkepesitesMegnevezeseListString = string.Join(", ", coList.Select(x => x.SzakkepesitesMegnevezese).Distinct().OrderBy(x => x).ToList());
        }

        public string IdsString { get; set; }

        [Display(Name = nameof(UjSzktSzakmajegyzekOsszerendelesResource.SzakkepesitesMegnevezeseList), ResourceType = typeof(UjSzktSzakmajegyzekOsszerendelesResource))]
        public string SzakkepesitesMegnevezeseListString { get; set; }

        [Range(0, 1000, ErrorMessageResourceName = nameof(UjSzktSzakmajegyzekOsszerendelesResource.KepzesreFogadhatoTanulokSzamaOutOfRange), ErrorMessageResourceType = typeof(UjSzktSzakmajegyzekOsszerendelesResource))]
        [Display(Name = nameof(UjSzktSzakmajegyzekOsszerendelesResource.KepzesreFogadhatoTanulokSzama), ResourceType = typeof(UjSzktSzakmajegyzekOsszerendelesResource))]
        public int? KepzesreFogadhatoTanulokSzama { get; set; }

        [StringLength(500, ErrorMessageResourceName = nameof(UjSzktSzakmajegyzekOsszerendelesResource.EszkozallomanyAvultsagaOutOfRange), ErrorMessageResourceType = typeof(UjSzktSzakmajegyzekOsszerendelesResource))]
        [Display(Name = nameof(UjSzktSzakmajegyzekOsszerendelesResource.EszkozallomanyAvultsaga), ResourceType = typeof(UjSzktSzakmajegyzekOsszerendelesResource))]
        public string EszkozallomanyAvultsaga { get; set; }

        [StringLength(500, ErrorMessageResourceName = nameof(UjSzktSzakmajegyzekOsszerendelesResource.EszkozokDarabszamaOutOfRange), ErrorMessageResourceType = typeof(UjSzktSzakmajegyzekOsszerendelesResource))]
        [Display(Name = nameof(UjSzktSzakmajegyzekOsszerendelesResource.EszkozokDarabszama), ResourceType = typeof(UjSzktSzakmajegyzekOsszerendelesResource))]
        public string EszkozokDarabszama { get; set; }

        [StringLength(500, ErrorMessageResourceName = nameof(UjSzktSzakmajegyzekOsszerendelesResource.EgyebEszkozallomanyInformacioOutOfRange), ErrorMessageResourceType = typeof(UjSzktSzakmajegyzekOsszerendelesResource))]
        [Display(Name = nameof(UjSzktSzakmajegyzekOsszerendelesResource.EgyebEszkozallomanyInformacio), ResourceType = typeof(UjSzktSzakmajegyzekOsszerendelesResource))]
        public string EgyebEszkozallomanyInformacio { get; set; }

        public List<UjSzktSzakmajegyzekOsszerendelesItemCo> ToCoList()
        {
            var result = new List<UjSzktSzakmajegyzekOsszerendelesItemCo>();
            var ids = IdsString.Split(',').ToList().Select(int.Parse).ToList();
            foreach (var id in ids)
            {
                result.Add(
                    new UjSzktSzakmajegyzekOsszerendelesItemCo
                    {
                        Id = id,
                        KepzesreFogadhatoTanulokSzama = KepzesreFogadhatoTanulokSzama,
                        EszkozallomanyAvultsaga = EszkozallomanyAvultsaga,
                        EszkozokDarabszama = EszkozokDarabszama,
                        EgyebEszkozallomanyInformacio = EgyebEszkozallomanyInformacio
                    });
            }

            return result;
        }
    }
}
