﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Web.Mvc;
using Kreta.BusinessLogic.Classes;
using Kreta.Resources;
using Kreta.Web.Attributes;

namespace Kreta.Web.Areas.Intezmeny.Models
{
    public class TanevRendjeModel
    {
        public TanevRendjeModel()
        {
            SelectedOsztalyCsoportIdList = new List<int>();
            ModifiedOsztalyCsoportList = new Dictionary<int, bool>();
            NapTipusaList = new List<SelectListItem>();
            CsengetesiRendList = new List<SelectListItem>();
        }

        public int? TanevRendjeId { get; set; }
        public DateTime TanevKezdoNap { get; set; }
        public DateTime TanevUtolsoNap { get; set; }

        [KretaDisplayName(273)]
        [KretaRequired(StringResourcesId = 2389)] //Dátum megadása kötelező!
        [DateRange(ErrorMessageResourceName = nameof(ErrorResource.ATanevRendDatumaNemErvenyes), ErrorMessageResourceType = typeof(ErrorResource))]
        public DateTime? Datum { get; set; }

        [KretaDisplayName(671)]
        [KretaRequired(StringResourcesId = 2387)] //Naptípus kiválasztása kötelező!
        public int? NapTipusa { get; set; }

        [KretaDisplayName(678)]
        public int? Nap { get; set; }

        [KretaDisplayName(265)]
        public int? Hetirend { get; set; }

        [KretaDisplayName(679)]
        public bool OsszesCsop { get; set; }

        [KretaDisplayName(14)]
        public int? CsengetesiRend { get; set; }

        [KretaDisplayName(97)]
        [KretaStringLength(255, ErrorMessageResourceName = nameof(IntezmenyResource.MegjegyzesMax), ErrorMessageResourceType = typeof(IntezmenyResource))]
        public string Megjegyzes { get; set; }

        [Display(Name = nameof(IntezmenyResource.UresOrarend), ResourceType = typeof(IntezmenyResource))]
        public bool UresOrarend { get; set; }

        [Display(Name = nameof(IntezmenyResource.OrarendiNap), ResourceType = typeof(IntezmenyResource))]
        public bool OrarendiNap { get; set; }

        [KretaRequired(ErrorMessageResourceName = nameof(ErrorResource.AzElteroOrarendSzerintiNapDatumKotelezo), ErrorMessageResourceType = typeof(ErrorResource))]
        [Display(Name = nameof(IntezmenyResource.ElteroOrarendSzerintiNapDatum), ResourceType = typeof(IntezmenyResource))]
        public DateTime? ElteroOrarendSzerintiTanitasNapDatum { get; set; }

        public List<int> SelectedOsztalyCsoportIdList { get; set; }

        public Dictionary<int, bool> ModifiedOsztalyCsoportList { get; set; }

        public List<SelectListItem> NapTipusaList { get; set; }

        public List<SelectListItem> CsengetesiRendList { get; set; }

        public bool IsElteroNapModosithato { get; set; }

        [Display(Name = nameof(OsztalyCsoportResource.EllatottKoznevelesiFeladatTipus), ResourceType = typeof(OsztalyCsoportResource))]
        public int? FeladatKategoriaId { get; set; }

        [Display(Name = nameof(CommonResource.Feladatellatasihely), ResourceType = typeof(CommonResource))]
        public int? FeladatEllatasiHelyId { get; set; }

        [Display(Name = nameof(IntezmenyResource.MukodesiHely), ResourceType = typeof(IntezmenyResource))]
        public int? MukodesiHelyId { get; set; }
    }
}
